<template>
    <div ref="container"></div>
</template>

<script setup lang="ts">
    import { onMounted, ref,watch } from 'vue';
    import Konva from 'konva';
    import { useI18n } from "vue3-i18n";


    import { PLan } from "@/types/entities";

    const { t } = useI18n()

    // eslint-disable-next-line
    const props = defineProps<{
        items: PLan[],
        isLoading?: boolean,

    }>();

    // eslint-disable-next-line
    const emit = defineEmits<{
        (event: "ouvrirFormEdit", id: string): void
        (event: "enleverDisableSurDeplacer", id?: string, deplace?:boolean): void
        (event: "envoyerDonne", xy: [number, number]): void
        (event: "resetStageForRedimension"):void
    }>()

    // eslint-disable-next-line
    defineExpose({
        resetRectangle,
        resetStageForRedimension,

    })

    const container = ref();
/*    const lstRect=ref<Konva.Rect[]>([])*/
    const layer = new Konva.Layer();
    let rectangleselectionne: Konva.Rect | null
    let stage: Konva.Stage
    let border: Konva.Rect
    let echelleL:number
    let echellelarg: number
    const largeurPlan = 6.4
    const longueurPlan=12

    onMounted(() => {
        window.addEventListener('resize', resizeStage);
        stage = new Konva.Stage({
            container: container.value,
            width: container.value.offsetWidth,
            height: 500,

        });
        border = new Konva.Rect({
            x: 0,
            y: 0,
            width: stage.width(),
            height: stage.height(),
            stroke: 'black',
            strokeWidth: 4 // La largeur de la bordure
        });
        layer.add(border)
        stage.add(layer);
        charger()
    });

    function resetRectangle() {
        rectangleselectionne!.setDraggable(!rectangleselectionne!.draggable())
        rectangleselectionne!.fill(rectangleselectionne!.fill() === "rgb(50,205,50)" ? "red" : "rgb(50,205,50)")
        rectangleselectionne=null
    }

    function resizeStage() {
        resetRectangle()
        emit("resetStageForRedimension")
    }

    function resetStageForRedimension() {
        stage.width(container.value.offsetWidth)
        border.width(stage.width())
        layer.draw()
        charger()
    }

    function clicDessinRectangle(e: Konva.KonvaEventObject<MouseEvent>) {

        const rect = e.target as Konva.Rect;
        if (!rectangleselectionne) {
            rect.setDraggable(!rect.draggable())
            rect.fill(rect.fill() === "rgb(50,205,50)" ? "red" : "rgb(50,205,50)")
            rectangleselectionne = rect
            emit("enleverDisableSurDeplacer",rectangleselectionne.id())
        } else if (rectangleselectionne == rect) {
            rectangleselectionne = null
            rect.setDraggable(!rect.draggable())
            rect.fill(rect.fill() === "rgb(50,205,50)" ? "red" : "rgb(50,205,50)")
            emit("enleverDisableSurDeplacer", rect.id(),true)
            charger()
        } else {
            alert(t(`global.messageerreurdessin`))
        }

    }

    function dragmove(e: Konva.KonvaEventObject<MouseEvent>) {
        const rect = e.target as Konva.Rect;
        if (rect.x() + rect.width() >= container.value.offsetWidth) {
            rect.x(container.value.offsetWidth - rect.width())
        }
        if (rect.x() <= 0) {
            rect.x(0)
        }
        if (rect.y() <= 0) { rect.y(0) }
        rect.y(rect.y() + rect.height() >= 500 ? 500 - rect.height() : rect.y());
        if (rect.draggable()) {
            const foundText = layer.find("#" + rect.id())[1] as Konva.Text;
            foundText.x(rect.x() + 10)
            foundText.y(rect.y() + rect.height() / 2 - 10)
        }
        emit("envoyerDonne",[Number((rect.x()/Number(echelleL)).toFixed(1)),Number((rect.y()/Number(echellelarg)).toFixed(1))])
    }

    function ouvrirEditPlan(e:Konva.KonvaEventObject<MouseEvent>){
         const rect = e.target as Konva.Rect;
             emit("ouvrirFormEdit", rect.id())
         

    }
    watch(() => props.items,() => charger());

    function charger() {
        layer.removeChildren()
        border = new Konva.Rect({
            x: 0,
            y: 0,
            width: stage.width(),
            height: stage.height(),
            stroke: 'black',
            strokeWidth: 4 // La largeur de la bordure
        });
        layer.add(border)
         echelleL=stage.width()/longueurPlan
         echellelarg=stage.height()/largeurPlan


        props.items.forEach((x:PLan) => {

            const rect = new Konva.Rect({
                x: Number((Number(x.x)*Number(echelleL)).toFixed(1)),
                y: Number((Number(x.y)*Number(echellelarg)).toFixed(1)),
                width: Number((Number(x.longueur)*Number(echelleL)).toFixed(1)),
                    height: Number((Number(x.largeur)*Number(echellelarg)).toFixed(1)),
                fill: 'rgb(50,205,50)',
                stroke: 'black',
                strokeWidth: 2,
                id: x.id
            });

            const text = new Konva.Text({
                x: rect.x() + 10,
                y: rect.y() + rect.height() / 2 - 10,
                text: x.nom,
                fontSize: 20,
                fontFamily: 'Arial',
                fill: 'black',
                id: x.id
            });

            layer.add(rect);
            layer.add(text);
            layer.draw();

            rect.on("click", clicDessinRectangle)
            rect.on("dragmove", dragmove)
            rect.on("dblclick", ouvrirEditPlan)

        })
    }

</script>